/*	
 *	cliptask.h
 *
 *	^XN (K[x[WRN^[K{!!)
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2004 Naoyuki Sawa
 *
 *	* Mon Jul 05 05:31:56 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 *	  GCgȂ^XŃAkeeptH_ɕۑ܂B
 */
#ifndef __CLIP_TASK_H__
#define __CLIP_TASK_H__

/*****************************************************************************
 *	
 *****************************************************************************/

/* AvP[V`̃^XNCxg֐vg^CvłB
 * [in]
 *	data		^XNf[^̈ւ̃|C^B
 *	code		AvP[V`̃CxgR[hB
 *	param		AvP[V`̃Cxgp[^B
 */
typedef void TASKEVENTHANDLER(void* data, int code, void* param);

/*
 *	ʃ^XNwb_ (^XNXg̃m[h\܂)
 */
typedef struct _TASK {
	TASKEVENTHANDLER* event_handler;	/* ^XNCxg֐ (NULL:~) */
	struct _TASK* next_task;		/* ̃^XNւ̃|C^ (NULL:I[) */
} TASK;
/* ʃ^XNwb_̒ɁAAvP[V`̃^XNf[^̈悪܂B */

/* V^XN쐬A^XNXgɒǉ܂B
 * [in]
 *	task_list	^XNXg擪ւ̃|C^̃|C^B
 *			KvɉāA^XNXg擪|C^XV܂B
 *	event_handler	AvP[V`̃^XNCxg֐B
 *			NULLw肷邱Ƃ͂ł܂B
 *	data_size	^XNf[^̈̃oCgB
 *			^XNf[^̈悪KvȂꍇ́A0w肵ĂB
 * [out]
 *	߂l		^XNf[^̈ւ̃|C^B
 *			data_size0w肵ꍇA0oCg̈ւ̗Lȃ|C^łB
 * [note]
 *	* ^XNf[^̈͏ԂŃ[NAĂ܂B
 *	  AvP[V疾IɃ[NAKv͂܂B
 */
void* task_start(TASK** task_list, TASKEVENTHANDLER* event_handler, int data_size);

/* ^XN~܂B
 * [in]
 *	data		^XNf[^̈ւ̃|C^B
 */
void task_stop(void* data);

/* ^XNCxg֐Ăяo܂B
 * [in]
 *	task_list	^XNXg擪ւ̃|C^̃|C^B
 *			KvɉāA^XNXg擪|C^XV܂B
 *	code		AvP[V`̃CxgR[hB
 *	param		AvP[V`̃Cxgp[^B
 */
void task_event(TASK** task_list, int code, void* param);

#endif /*__CLIP_TASK_H__*/
